<?php
/**
* Plugin that inserts maxiGos sgf player (http://jeudego.org/maxiGos/) into Joomla articles.
* @author FM&SH
* @copyright FM&SH and various GPL sources, 2013-2021
* @link jeudego.org/maxiGos
* @package maxiGos sgf player
* @version 2.01
* @license GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
*/

// No direct access allowed to this file
defined('_JEXEC') or die('Restricted access');

// Import Joomla! Plugin library file
jimport('joomla.plugin.plugin');

// The Content plugin maxigos
class plgContentMaxigos extends JPlugin
{
	/*
	* Plugin that loads maxigos sgf player within content
	*/

	// onContentPrepare: look for plugin instances and process the plugin if any
	public function onContentPrepare($context,&$row,&$params,$page=0)
	{
		$maxigosTag=$this->params->def('maxigosTag','gos');
		// Simple performance check to determine whether bot should process further
		if (JString::strpos($row->text,'{'.$maxigosTag)===false) return true;
		
		// Expression to search for
		// Just get a global match
		$regex='/{'.$maxigosTag.'[^}]*}/i';
		
		// Check whether plugin has been unpublished
		if (!$this->params->get('enabled',1))
		{
			$row->text=preg_replace($regex,'',$row->text);
			return true;
		}
		
	 	// Find all plugin instances and put the result in $matches
		preg_match_all($regex,$row->text,$matches);
	 	$count=count($matches[0]);
				
	 	// Plugin only processes if there are any plugin instances to replace
	 	if ($count)
	 	{
			// Get plugin parameters
			$sgfFolder=$this->params->def('sgfFolder','../images/sgf');
			$maxigosFolder=$this->params->def('maxigosFolder','plugins/content/maxigos');
			$maxigosConfig=$this->params->def('maxigosConfig','basic');
			$maxigosTheme=$this->params->def('maxigosTheme','neo-classic');
			$maxigosLang=$this->params->def('maxigosLang','en');
			$maxigosToLower=$this->params->def('maxigosToLower','0');
			$maxigosSgfAsIs=$this->params->def('maxigosSgfAsIs','0');
	 		$this->_process($row,$matches,$count,$regex,$maxigosTag,$sgfFolder,$maxigosFolder,$maxigosConfig,$maxigosTheme,$maxigosLang,$maxigosToLower,$maxigosSgfAsIs);
		}
		// No return value
	}

	// _process: the function processing the plugin (replace plugin instances by html code)
	protected function _process(&$row,&$matches,$count,$regex,$maxigosTag,$sgfFolder,$maxigosFolder,$maxigosConfig,$maxigosTheme,$maxigosLang,$maxigosToLower,$maxigosSgfAsIs)
	{
	 	for ($i=0;$i<$count;$i++)
		{
			$params=array();
			$load=str_replace('&nbsp;',' ',$matches[0][$i]);
			$load=preg_replace("/^{".$maxigosTag." /","",$load);
			$load=preg_replace("/}$/","",$load);
			if(preg_match("/^([^}]+)(,\s*([A-Za-z0-9_-]+))$/",$load,$loads))
			{
				$loadsCount=count($loads);
				if($loadsCount>0) $params[0]=$loads[1];
				if($loadsCount>2) $params[1]=$loads[3];
			}
			else if(preg_match("/^([^}]+)$/",$load,$loads))
			{
				$loadsCount=count($loads);
				if($loadsCount>0) $params[0]=$loads[1];
			}
			$km=count($params);
			for($k=0;$k<$km;$k++)
			{
				// remove any string between < and >
				$params[$k]=preg_replace("/<[^>]+>/","",$params[$k]);
				if($k==0)
				{
					$params[$k]=trim($params[$k]);
				}
				if($k==1)
				{
					$params[$k]=preg_replace("/[^A-Za-z0-9_-]/","",$params[$k]);
				}
			}
			if (($maxigosSgfAsIs=="1")&&count($params)&&preg_match("/\(/",$params[0]))
			{
				$player=$this->_load2($params,$maxigosFolder,$maxigosConfig,$maxigosTheme,$maxigosLang);
			}
			else
			{
				$player=$this->_load($params,$sgfFolder,$maxigosFolder,$maxigosConfig,$maxigosTheme,$maxigosLang,$maxigosToLower);
			}
			$row->text=str_replace($matches[0][$i],$player,$row->text);
	 	}
	  	// Removes remaining plugin instances if any
		$row->text=preg_replace($regex,'',$row->text);
	}

	// _load: a function loading the plugin (generate the html code to insert in the text)
	//        used when sgf source is a sgf file
	protected function _load($params,$sgfFolder,$maxigosFolder,$maxigosConfig,$maxigosTheme,$maxigosLang,$maxigosToLower)
	{
		static $maxigosCounter;
		if(isset($maxigosCounter)) $maxigosCounter++;
		else $maxigosCounter=1;
		$paramsCount=count($params);
		if ($paramsCount>0) $sgfFilename=$params[0];
		else $sgfFilename='';
		if(strlen($sgfFilename)>64) $sgfFilename='';
		if ($maxigosToLower=='1') $sgfFilename=strtolower($sgfFilename);
		if ($paramsCount>1) $cfg=$params[1];
		else if ($maxigosConfig!='') $cfg=$maxigosConfig;
		else $cfg="basic";
		if(!preg_match("/^[A-Za-z0-9_-]+$/",$cfg)) $cfg="basic";
		if(strlen($cfg)>64) $cfg="basic";
		/*
		$contents='';
		$contents.='<iframe name="maxigos-iframe'.$maxigosCounter.'"';
		$contents.=' width="100%" frameBorder="0"';
		$contents.=' src="'.JURI::root().$maxigosFolder.'/iframe.php?';
		$contents.='sgf='.urlencode(JURI::root().$sgfFolder.'/'.$sgfFilename);
		$contents.='&config='.$cfg;
		$contents.='&theme='.$maxigosTheme;
		$contents.='&lang='.$maxigosLang;
		$contents.='&path='.urlencode(JURI::root().$sgfFolder);
		$contents.='"></iframe>';
		*/
		// no iframe version
		$contents='';
		$contents.='<script';
		$contents.=' src="'.$maxigosFolder.'/_maxigos/_i18n/maxigos-i18n-'.$maxigosLang.'.js">';
		$contents.='</script>';
		$contents.='<script';
		$contents.=' data-maxigos-l="'.$maxigosLang.'"';
		$contents.=' src="'.$maxigosFolder.'/_maxigos/_alone/maxigos-'.$maxigosTheme.'-'.$cfg.'.js">';
		$contents.=JURI::base().$sgfFolder.'/'.$sgfFilename;
		$contents.='</script>';
		return $contents;
	}
	// _load2: another function loading the plugin (generate the html code to insert in the text)
	//         used when sgf source is a sgf record
	protected function _load2($params,$maxigosFolder,$maxigosConfig,$maxigosTheme,$maxigosLang)
	{
		static $maxigosCounter;
		if(isset($maxigosCounter)) $maxigosCounter++;
		else $maxigosCounter=1;
		$paramsCount=count($params);
		if ($paramsCount>0) $sgf=$params[0];
		else $sgf="";
		if(strlen($sgf)>4194304) $sgf='';
		if ($paramsCount>1) $cfg=$params[1];
		else if ($maxigosConfig!='') $cfg=$maxigosConfig;
		else $cfg="basic";
		if(!preg_match("/^[A-Za-z0-9_-]+$/",$cfg)) $cfg="basic";
		if(strlen($cfg)>64) $cfg="basic";
		/*
		$contents='';
		$contents.='<iframe name="maxigos-iframe'.$maxigosCounter.'r" width="100%" frameBorder="0" src="'.JURI::root().$maxigosFolder.'/wait.php"></iframe>';
		$contents.='<form id="maxigos-form'.$maxigosCounter.'r" action="'.JURI::root().$maxigosFolder.'/iframe.php" target="maxigos-iframe'.$maxigosCounter.'r" method="post">';
		$contents.='<input name="lang" type="hidden" value="'.$maxigosLang.'">';
		$contents.='<input name="config" type="hidden" value="'.$cfg.'">';
		$contents.='<input name="theme" type="hidden" value="'.$maxigosTheme.'">';
		$contents.='<input name="sgf" type="hidden" value="'.urlencode($sgf).'">';
		$contents.='<input name="path" type="hidden" value="'.urlencode(JURI::root().$sgfFolder).'">';
		$contents.='</form>';
		$contents.='<script src="'.JURI::root().$maxigosFolder.'/mgosFormSubmit.js"></script>';
		*/
		// no iframe version
		$contents='';
		$contents.='<script';
		$contents.=' src="'.$maxigosFolder.'/_maxigos/_i18n/maxigos-i18n-'.$maxigosLang.'.js">';
		$contents.='</script>';
		$contents.='<script';
		$contents.=' data-maxigos-l="'.$maxigosLang.'"';
		$contents.=' src="'.$maxigosFolder.'/_maxigos/_alone/maxigos-'.$maxigosTheme.'-'.$cfg.'.js">';
		$contents.=$sgf;
		$contents.='</script>';
		return $contents;
	}
}
?>